﻿namespace TabsStudioShaper
{
    public class Shaper : TabsStudioExt.ITabsStudioAddin, TabsStudioExt.IStyler
    {
        public void OnConnection(TabsStudioExt.ITabsStudioEngine engine_, EnvDTE80.DTE2 dte)
        {
            engine = engine_;
            engine.Initialize += OnInitialize;
            zorderManager = new ZOrderManager(engine);
        }

        public void OnDisconnection()
        {
            engine.Initialize -= OnInitialize;
            zorderManager.Close();
        }

        public string GetNamespacesForResourceDictionary()
        {
            return "xmlns:TabsStudioShaper=\"clr-namespace:TabsStudioShaper;assembly=Shaper\"";
        }

        private void OnInitialize(object sender, System.EventArgs e)
        {
            UpdatePresentationStyle();
        }

        private void UpdatePresentationStyle()
        {
            TabsStudioExt.Presentation presentation = new TabsStudioExt.Presentation("", "");
            {
                TabsStudioExt.PresentationStyle style = new TabsStudioExt.PresentationStyle();
                style.Setters.Add(LoadString("TabsMargin.xml"));
                presentation.Styles.Add("TabsStudio:Tabs", style);
            }
            {
                TabsStudioExt.PresentationStyle style = new TabsStudioExt.PresentationStyle();
                style.Setters.Add(LoadString("TabTemplate.xml"));
                presentation.Styles.Add("TabsStudio:Tab", style);
            }
            engine.UpdatePresentationStyles("Shaper", presentation);
        }

        private static string LoadString(string resource)
        {
            using (System.IO.Stream stream = System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream(
                "Shaper.Resources." + resource))
            {
                using (System.IO.StreamReader reader = new System.IO.StreamReader(stream))
                {
                    return reader.ReadToEnd();
                }
            }
        }

        private TabsStudioExt.ITabsStudioEngine engine;
        private ZOrderManager zorderManager;
    }
}
